
/*!
 * The structure of data entailed in CommonKnowledge, for each knowledge field:
 * - 1. The number of instances of a knowledge field;
 * - 2. The performance of a knowledge field.
 * 
 *  \author Sirio Capizzi
 *  \author Guido Fioretti
 *  \author Ruggero Rossi
 *  \copyright GNU Public License.
 */
public class CommonKnowledgeData {
	public int KFIs;	///< Knowledge field instances.
	public double performance;	///< The performance of this knowledge field.
	
	/**
	 * 
	 */
	public CommonKnowledgeData()
	{
		KFIs = 0;
		performance = 0.0;
	}
	
	/**
	 * 
	 * @param kfis
	 * @param p
	 */
	public CommonKnowledgeData(int kfis, double p)
	{
		KFIs = kfis;
		performance = p;
	}
}
