
/*!
 * The structure of expertise values in knowledge items:
 * - 1. The current expertise of a knowledge field;
 * - 2. The maximum value the expertise of a knowledge field attained.
 * 
 *  \author Sirio Capizzi
 *  \author Guido Fioretti
 *  \author Ruggero Rossi
 *  \copyright GNU Public License.
 */
public class ExpertiseData {
	public double expertise;	///< Current expertise.
	public double expertiseAttained;	///< The maximum expertise ever 
										///< attained by this knowledge field.
	
	/**
	 * 
	 */
	public ExpertiseData()
	{
		expertise=0.0f;
		expertiseAttained=0.0f;
	}
	
	/**
	 * 
	 * @param e
	 * @param eAttained
	 */
	public ExpertiseData(double e, double eAttained)
	{
		expertise = e;
		expertiseAttained = eAttained;
	}
}
