// SE INSERISCO SIMILARITY INDEX NELLA SCELTA DEI RIVALI, DEVO ANCHE MODIFICARE 
// L.48
import java.util.*;


/*!
 * Knowledge operators which:
 * - check whether two knowledge fields are included in one another;
 * - check whether two bodies of knowledge have any intersecting field;
 * - measure the similarity of two knowledge bases;
 * - implement Dempster-Shafer's combination rule.
 * 
 *  \author Sirio Capizzi
 *  \author Guido Fioretti
 *  \author Ruggero Rossi
 *  \copyright GNU Public License.
 */
public class KnowledgeOperators {

    
	/**
	 * Checks whether two bodies of knowledge have any intersecting field.
     * Needs CommonKnowledge.
	 *
	 * @param K1
	 * @param K2
	 * @return
	 */
	public static boolean isThereAnyIntersection(KnowledgeBase K1, KnowledgeBase K2) {
		   System.out.println("isThereAnyIntersection e' stato chiamato e chiama intersects: K1 = " + K1 + " K2 = " + K2);
System.out.println("dentro isThereAnyIntersection K1.fields = " + K1.fields());
System.out.println("dentro isThereAnyIntersection K2.fields = " + K2.fields());
		   boolean answer = false;
    	for(KnowledgeField j: K1.fields())
    		for(KnowledgeField k: K2.fields())   
{
System.out.println("dentro isThereAnyIntersection j = " + j.instances[0].getInstanceOfAspect() + " " + j.instances[1].getInstanceOfAspect());
System.out.println("dentro isThereAnyIntersection k = " + k.instances[0].getInstanceOfAspect() + " " + k.instances[1].getInstanceOfAspect());
boolean interseca = j.intersects(k);
System.out.println("intersects restituisce questo valore: " + interseca);
    			if (j.intersects(k))
    				answer = true;
 }
   System.out.println("isThereAnyIntersection risponde con quello che gli dice intersects: " + answer);
		return answer;
	}
	
	/**
	 * Evaluates and index of similarity of two knowledge bases. Needs 
	 * CommonKnowledge. Yields values in [0,1] where 0 means no similarity, 
	 * 1 means equality.
	 * Each knowledge field of a knowledge base is considered only once.
	 * Among its similarity values with all knowledge fields of the other 
	 * knowledge base, the highest is taken.
	 * If a knowledge field has two equal similarity values with two other 
	 * knowledge fields,
	 * the one intersection is chosen whose two knowledge fields have lowest 
	 * similarity values elsewhere.
	 * In early versions, this was used to select rivals. In more recent version
	 * , it is only used in order to draw the similarity network.
	 *
	 * @param K1
	 * @param K2
	 * @return
	 */
	public static double getSimilarityIndex(KnowledgeBase K1, KnowledgeBase K2) {		
		int rows=K1.getNumFields();
		int columns=K2.getNumFields();
		
		if( (rows==0) || (columns==0) )
			return 0.0f;
		
		double similarityMatrix[][] = new double [rows][columns];
			
    	int n=0;
		for(KnowledgeField k: K1.fields()) {
    		
			int m = 0;    		    		
    		for(KnowledgeField j: K2.fields()) {
    			similarityMatrix[n][m] = j.intersectionValue(k);    			 
    			m++;    			
			}
    		
    		n++; 
    	}
    	
		boolean K1_free[]=new boolean[rows];	// indica quali knowledge field 
												// di K1 sono ancora disponibili
		for(int i=0; i<rows; i++)
			K1_free[i]=true;
		
		boolean K2_free[]=new boolean[columns];
		for(int i=0; i<columns; i++)
			K2_free[i]=true;
		
		double aggregateIntersection =0;

		// qua calcoliamo le intersezioni
		
		// prima quelle complete
		int found=0;
		for(int r=0; r<rows; r++)
		{
			if(!K1_free[r])
				continue;
			
			for(int c=0; c<columns; c++)
			{
				if(!K2_free[c])
					continue;
	
				//if(similarityMatrix[r][c]==1)
				if(similarityMatrix[r][c]>0.999f)	// meglio usare un epsilon, 
													// non 1.0 puro
				{
					aggregateIntersection+=1.0f;
					K1_free[r]=false;	// e invalidiamo riga e colonna: c'è già 
										// una similitudine che li coinvolge
					K2_free[c]=false;
					found++;
					break;	// break necessario perchè vengono generati più di 
							// un knowledge field uguali nella stessa kbase !
				}
			}
		}
		
		// occupiamoci ora delle similitudini non complete
		// ricopiamo tutto in una nuova matrice saltando righe e colonne delle 
		// similitudini complete trovate
		int b_rows=rows-found;
		int b_columns=columns-found;
		
		if( (b_rows!=0) && (b_columns!=0) )		    
		{
			double b_similarityMatrix[][] = new double [b_rows][b_columns];
			
			for(int r=0, b_r=0; r<rows; r++)
			{
				if(!K1_free[r])
					continue;						
				
				for(int c=0, b_c=0; c<columns; c++)
				{
					if(!K2_free[c])
						continue;	
					
					b_similarityMatrix[b_r][b_c]=similarityMatrix[r][c];
					b_c++;
				}
				
				b_r++;
			}
			
			// ora dobbiamo trovare la combinazione massima delle intersezioni: 
			// dobbiamo provare tutte le combinazioni riga-colonna e tenere la 
			// maggiore
			
			
			double max_sum=0;
			int pos_columns[]=new int [b_rows];	// per ogni riga tiene conto 
												// della posizione delle colonne
			
			max_sum=maxSimilaritySum(b_similarityMatrix, b_rows, b_columns, 
					pos_columns, 0);
						
			aggregateIntersection+=max_sum;	//sommiamo la combinazione massima 
											// delle intersezioni	
		}			
		
		double num_intersections = (double)Math.min(rows, columns);		
    	return aggregateIntersection/num_intersections;
	}
    
	/**
	 * simil = matrice delle intersezioni
	 * n_rows, n_colums numero di righe e colonne
	 * pos_columns la posizione di ogni colonna per ogni riga 
	 * (la configurazione, è una disposizione di colonne per le righe)
	 * r,c riga e colonna alla quale siamo arrivati
	 * 
	 * - 1. scegliere riga e colonna
	 * - 2. siamo alla fine? calcola la similarity sum e restituiscila come 
	 * max_sum (return) 
	 * altrimenti
	 * - 3. richiama in modo ricorsivo maxSimilaritySum con un ciclo 
	 * for(int i=0; i<num_col; i++) combinazione per ogni colonna -> chiamata 
	 * ricorsiva a maxsimilaritysum() controllo di impossibilità 
	 * (colonne uguali)
	 * - 4. se il valore è maggiore a max_sum, sostituiscilo
	 * - 5. restituisci max_sum
	 * 
	 * @param simil Intersections matrix
	 * @param n_rows Rows number
	 * @param n_columns Columns number
	 * @param pos_columns Position of each column for each row (the 
	 * configuration, is a disposition of of columns for rows)
	 * @param r row where we are arrived
	 * @return
	 */
	private static double maxSimilaritySum(double simil[][], int n_rows, 
			int n_columns,  int pos_columns[], int r)
	{				
		double max_sum=0;		
	
		if(r==n_rows)	// abbiamo costruito una disposizione intera, calcoliamo 
						//il valore e lo restituiamo
		{
			for(int i=0; i<n_rows; i++)
			{
				max_sum+=simil[i][pos_columns[i]];
			}
			return max_sum;
		}
		
		// altrimenti proviamo tutte le disposizioni per una riga
		for(int i=0; i<n_columns; i++)
		{
			// guardiamo se la colonna i non sia già stata usata in righe 
			// precedenti
			boolean used=false;
			for(int j=0; j<r; j++)
			{
				if(pos_columns[j]==i)
				{
					used=true;
					break;
				}
			}
			
			if(used==true)	// gia' usata, salta questa disposizione
				continue;
			
			pos_columns[r]=i;
			double value = 
					maxSimilaritySum(simil, n_rows, n_columns, pos_columns, r+1);	
				// inviamo alla riga successiva
			
			if(value>max_sum)
				max_sum=value;
		}
		
		
		return max_sum;				
	}

	
	
	
	
	/**
	 * Implements Dempster-Shafer's combination rule.
     * Receives two bodies of knowledge that combines into one, which returns. 
     * Also needs common knowledge as argument.
	 *
	 * @param startingEvidence
	 * @param newEvidence
	 * @param frame
	 * @return
	 */
     public static KnowledgeBase dempsterShafer(KnowledgeBase startingEvidence, 
    		KnowledgeBase newEvidence, CommonKnowledge frame) {
    	KnowledgeBase A = startingEvidence;	// includes the first testimony and 
    										// can host the new intersections 
    										// and inclusions eventually 
    										// generated
    	KnowledgeBase B = newEvidence;  // the new, surprising evidence
		KnowledgeBase C = new KnowledgeBase(A.getMaxExpertise());  // this will be returned 
System.out.println("dempsterShafer viene chiamato con A = " + A + " e B = " + B);
System.out.println("e dentro di loro A.fields = " + A.fields() + " e B.fields = " + B.fields());
System.out.println("A isEmpty = " + A.isEmpty());
System.out.println("B isEmpty = " + B.isEmpty());
		
		// If the starting knowledge does not exist.
		if (A == null) {
			System.out.println("A e' null");
			C = B;
		}

		// If the starting knowledge exists, but the novel evidence either does not exist or has no intersection
		if (A != null && (B == null || B != null && !isThereAnyIntersection(A, B))) {
			if (B == null)
				System.out.println("B e' null");
			else
System.out.println("dempsterShafer chiama isThereAnyIntersection: non ci sono intersezioni");
			C = A;
		}

    	// Checks whether there is any intersection, then proceeds.
    	if (A != null && B!= null && isThereAnyIntersection(A, B)) {
System.out.println("Ci sono intersezioni dei campi di conoscenza");
    		// firms with no knowledge fields are eliminated
        	
    		
        	// Initializes the denominator, that is decreased if two knowledge fields intersect.
        	double denominator = 1;
        	// Scans the knowledge fields of the two knowledge bases and examines each pair.
        	for(Map.Entry<KnowledgeField,ExpertiseData> je: A.getKnowledge())
        		for(Map.Entry<KnowledgeField,ExpertiseData> ke: B.getKnowledge()) {
        			KnowledgeField j=je.getKey();  // j and k denote knowledge fields
        			KnowledgeField k=ke.getKey();
        			double jv=je.getValue().expertise;
        			double kv=ke.getValue().expertise;
        			double maxExpertise = Math.max(jv, kv);
        			
        			
        			
        			// If the two fields do not intersect.
        			if (!j.intersects(k))
        				denominator -= jv*kv;
        			// The numerator is computed.

        			
        			
        			// If the two fields of knowledge coincide.
        			if (j.isEquivalent(k)) {
        				C.setField(j, maxExpertise);
        			}     
        			
        			// If a field of A includes a field of B.
           			if (j.includes(k) && !j.isEquivalent(k)) { 
        				C.setField(j, maxExpertise);
        			}
           			
        			// If a field of B includes a field of A.
        			else if(k.includes(j) && !k.isEquivalent(j)) { 
        				C.setField(k, maxExpertise);
        			}  
           			
        			// If a field of A intersects but is neither equivalent, 
        			// nor includes or is included in a field of B.
        			else if (j.intersects(k) && j.includes(k) == false && k.includes(j) == false && 
        					j.isEquivalent(k) == false && k.isEquivalent(j) == false) {
        				// C will be given an expertise whose numerator is here initialized.
        				double numerator = 0.0;
        				// A new field is created.
        				KnowledgeField Ckf = new KnowledgeField();
        				// The aspects spanned by j and k.
        				BusinessElementInstance[] ba1 = j.instances;
        				BusinessElementInstance[] ba2 = k.instances;
        				for (int i=0; i<Model.numBusinessElements; i++) {
        					// Since Dempster-Shafer's rule is iterated, it may meet undefined business elements.

        					// If only ba1[i] is undefined
        					if (ba1[i].isAspectUndefined() == true && ba2[i].isAspectUndefined() == false)
{
System.out.println("DENTRO dempster, alla C viene aggiunta la instance " + ba2[i].getInstanceOfAspect() + " dell'aspetto " + i +" perche' l'altra e' undefined");
        						Ckf.addBEI(ba2[i]);
        						numerator += kv/Model.newBusinessElements;
}	  

        					// If only ba2[i] is undefined
        					if (ba2[i].isAspectUndefined() == true && ba1[i].isAspectUndefined() == false)
{
System.out.println("DENTRO dempster, alla C viene aggiunta la instance " + ba1[i].getInstanceOfAspect() + " dell'aspetto " + i +" perche' l'altra e' undefined");
        						Ckf.addBEI(ba1[i]);
        						numerator += jv/Model.newBusinessElements;
}	  
        					// If neither ba1[i] nor ba2[i] are undefined
        					if (ba1[i].isAspectUndefined() == false &&	ba2[i].isAspectUndefined() == false) {
        						// If these two aspects are equivalent to one another.
        						if (ba1[i].getInstanceOfAspect() == ba2[i].getInstanceOfAspect()) {
System.out.println("DENTRO dempster, alla C viene aggiunta la instance " + ba1[i].getInstanceOfAspect() + " dell'aspetto " + i);
        							Ckf.addBEI(ba1[i]);
            						numerator += maxExpertise/Model.newBusinessElements;
        						}	  
        						// If these two aspects are different from one another.
        						else {
        							BusinessElementInstance newUndefBEI = new BusinessElementInstance(i, true);
System.out.println("DENTRO dempster viene aggiunta un'undefined");
        							Ckf.addBEI(newUndefBEI);
        						}
        					}
        					
        					// If both ba1[i] and ba2[i] are undefined
        					if (ba1[i].isAspectUndefined() == true &&	ba2[i].isAspectUndefined() == true) {
    							BusinessElementInstance newUndefBEI = new BusinessElementInstance(i, true);
System.out.println("DENTRO dempster viene aggiunta un'undefined");
    							Ckf.addBEI(newUndefBEI);        						
        					}
        				}
        				C.setField(Ckf, jv*kv);
        			}	  
        		}
    			
        	// Normalizes expertise by dividing it by the denominator.
        	for(Map.Entry<KnowledgeField,ExpertiseData> i: C.getKnowledge()) {
        		C.setField(i.getKey(), i.getValue().expertise/denominator);
        	}

    	}  // ends A!=null && B!=null && isThereAnyIntersection
    	// Returns the compound rival knowledge that it has computed.
    	return C;
    }  // ends dempsterShafer
     
     
     
}  // ends KnowledgeOperators

