import org.jfree.chart.ChartPanel;
import org.jfree.chart.ChartUtilities;


import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.CategoryAxis;
import org.jfree.chart.axis.CategoryLabelPositions;
import org.jfree.chart.labels.ItemLabelAnchor;
import org.jfree.chart.labels.ItemLabelPosition;
import org.jfree.chart.labels.StandardCategoryItemLabelGenerator;
import org.jfree.ui.ApplicationFrame;
import org.jfree.ui.RefineryUtilities;
import org.jfree.ui.TextAnchor;
import org.jfree.chart.plot.CategoryPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.renderer.category.LineAndShapeRenderer;
import org.jfree.data.category.DefaultCategoryDataset;

public class LineChart extends ApplicationFrame {
   
   public LineChart( String applicationTitle , String chartTitle, DefaultCategoryDataset dataset) {
      super(applicationTitle);
      JFreeChart lineChart = ChartFactory.createLineChart(
         chartTitle,
         "Step","Values",
         dataset,
         PlotOrientation.VERTICAL,
         true,true,false);
         
      ChartPanel chartPanel = new ChartPanel( lineChart );
      chartPanel.setPreferredSize( new java.awt.Dimension( 700 , 550 ) );
      setContentPane( chartPanel );
      
      // rotate xlabel to 90 degree (vertical) because words are too long to display horizontally
      CategoryAxis axis = lineChart.getCategoryPlot().getDomainAxis();
      //axis.setCategoryLabelPositions(CategoryLabelPositions.UP_90);
      
      CategoryPlot plot = (CategoryPlot) lineChart.getPlot();
      LineAndShapeRenderer renderer = (LineAndShapeRenderer) plot.getRenderer();
      renderer.setShapesVisible(true);
      renderer.setItemLabelsVisible(true);
      renderer.setSeriesVisible(true);
      
      //display chart values
      renderer.setBaseItemLabelGenerator(new StandardCategoryItemLabelGenerator());
      renderer.setBaseItemLabelsVisible(true);
      ItemLabelPosition position = new ItemLabelPosition(ItemLabelAnchor.OUTSIDE12, 
              TextAnchor.TOP_CENTER);
      renderer.setBaseNegativeItemLabelPosition(position); 
      
      
      
      
  
   }
   // display line chart
   public void displayLineChart(String windowstitle, String linetitle,DefaultCategoryDataset data_set )
   {
	   LineChart chart = new LineChart(windowstitle ,linetitle, data_set);

	      chart.pack( );
	      RefineryUtilities.centerFrameOnScreen( chart );
	      chart.setVisible( true );
	      
	      
   }
   
  
}