
/*!
 * This object is used in order to model vicarious learning.
 * It entails the learning firm, its source of inspiration, exploration/
 * exploitation and synchronization information
 * 
 *  \author Sirio Capizzi
 *  \author Guido Fioretti
 *  \author Ruggero Rossi
 *  \copyright GNU Public License.
 */
public class FirmAction {
	public Firm actor;	///< The firm who does the action.
	public Firm inspiration; ///< The firm from whom the action is copied.
	public int action;	///< The type of action.
	public int step;
	public static final int action_exploration=1;
	public static final int action_exploitation=2;
	
	/**
	 * 
	 * @param actorFirm
	 * @param inspirationFirm
	 * @param actionType
	 * @param actionStep
	 */
	FirmAction(Firm actorFirm, Firm inspirationFirm, int actionType, 
			int actionStep)
	{
		actor=actorFirm;
		inspiration=inspirationFirm;
		action=actionType;
		step=actionStep;
	}
}
