
/*!
 * This object is used in order to write information on graphs.
 * 
 *  \author Sirio Capizzi
 *  \author Guido Fioretti
 *  \author Ruggero Rossi
 *  \copyright GNU Public License.
 */
public class FirmHistoricAction {
	public int actor_id;	///< the firm who does the action
	//public boolean is_actor_clustered;
	public int inspiration_id; ///< the firm from whom the action is copied
	//public boolean is_inspiration_clustered;
	public int action;	///< the type of action:
	public static final int action_exploration=1;
	public static final int action_exploitation=2;

	/**
	 * 
	 * @param actorFirm_id
	 * @param inspirationFirm_id
	 * @param actionType
	 */
	//FirmHistoricAction(int actorFirm_id, boolean actor_clustered, 
	//int inspirationFirm_id, boolean inspiration_clustered, int actionType)
	FirmHistoricAction(int actorFirm_id,  int inspirationFirm_id,  
			int actionType)
	{
		actor_id=actorFirm_id;
		//is_actor_clustered=actor_clustered;
		inspiration_id=inspirationFirm_id;
		//is_inspiration_clustered=inspiration_clustered;
		action=actionType;
	
	}
	
	/**
	 * 
	 * @param model
	 * @param actorFirm
	 * @param inspirationFirm
	 * @param actionType
	 */
	FirmHistoricAction(Model model, Firm actorFirm, Firm inspirationFirm, 
			int actionType)
	{
		actor_id=actorFirm.getIdentity();
		inspiration_id=inspirationFirm.getIdentity();
		action=actionType;
	}
}
