
/*!
 * A matrix to draw graphs.
 * m x m Matrix. Each (m,n) elements contains informations about similarity 
 * between m's and n's BEI:
 * the first bit represents the first BEI, the second bit represents the 
 * second BEI and so on.
 * 
 *  \author Guido Fioretti
 *  \author Ruggero Rossi
 *  \copyright GNU Public License.
 */
public class LayeredMatrix {
	public final int first_bit=1;
	public final int second_bit=2;
	public final int third_bit=4;
	public final int fourth_bit=8;
	public final int fifth_bit=0x16;
	
	// i 5 bit possono rappresentare 5 diversi BEI
	// oppure usando solo i primi due possono rappresentare exploration (1) o 
	// exploitation (2)
	
	public int n_layers;
	public int m[][];
	
	/**
	 * 
	 * @param size
	 * @param layers
	 */
	LayeredMatrix(int size, int layers)
	{
		m=new int[size][size];
		n_layers=layers;
	}
}
